import { SymbolKeysNotSupportedError } from "../errors/index.js";
import { getMetadataStorage } from "../metadata/getMetadataStorage.js";
export function Directive(nameOrDefinition) {
    return (targetOrPrototype, propertyKey, _descriptor) => {
        const directive = { nameOrDefinition, args: {} };
        if (typeof propertyKey === "symbol") {
            throw new SymbolKeysNotSupportedError();
        }
        if (propertyKey) {
            getMetadataStorage().collectDirectiveFieldMetadata({
                target: targetOrPrototype.constructor,
                fieldName: propertyKey,
                directive,
            });
        }
        else {
            getMetadataStorage().collectDirectiveClassMetadata({
                target: targetOrPrototype,
                directive,
            });
        }
    };
}
