import { SymbolKeysNotSupportedError } from "../errors/index.js";
import { getMetadataStorage } from "../metadata/getMetadataStorage.js";
export function PubSub(triggerKey) {
    return (prototype, propertyKey, parameterIndex) => {
        if (typeof propertyKey === "symbol") {
            throw new SymbolKeysNotSupportedError();
        }
        getMetadataStorage().collectHandlerParamMetadata({
            kind: "pubSub",
            target: prototype.constructor,
            methodName: propertyKey,
            index: parameterIndex,
            triggerKey,
        });
    };
}
